<?php
	// Conversor Helvia/WordPress 1.0
	// Pablo Murillo Ávila


	echo ("[".date('H:i:s')." INFO]: Conversor Helvia/WordPress.\n");
	include ("config.php");
	error_reporting(E_ERROR | E_PARSE);
	function slug($text) {
		$text = preg_replace('~[^\pL\d]+~u', '-', $text);
		$text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);
		$text = preg_replace('~[^-\w]+~', '', $text);
		$text = trim($text, '-');
		$text = preg_replace('~-+~', '-', $text);
		$text = strtolower($text);
		if (empty($text)) {
			return '';
		}
		return $text;
	}
	function usuario($text) {
		$text = preg_replace('~[^\pL\d]+~u', '', $text);
		$text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);
		$text = preg_replace('~[^-\w]+~', '', $text);
		$text = trim($text, '-');
		$text = preg_replace('~-+~', '', $text);
		$text = strtolower($text);
		if (empty($text)) {
			return '';
		}
		return $text;
	}
	function emoticonos($text) {
		$text = preg_replace('<img(.*)emotions(.*)/>', '', $text);
		if (empty($text)) {
			return '';
		}
		return $text;
	}

	// Conexión a la base de datos
	echo ("[".date('H:i:s')." INFO]: Conectando a la base de datos...\n");
	$conexion=new mysqli($servidor,$usuario,$contrasena,$basededatos);
	if ($conexion->connect_error) {
		echo ("[".date('H:i:s')." ERROR]: Error de conexión a la base de datos.\n");
		die();
	}
	else {
		echo ("[".date('H:i:s')." INFO]: Conexión establecida a la base de datos.\n");
	}

	// Creación del achivo y cabecera
	echo ("[".date('H:i:s')." INFO]: Creando archivo de importación de WordPress...\n");
	$archivo = fopen($nombre_archivo,"w+");
	fwrite ($archivo,'<?xml version="1.0" encoding="UTF-8"?>

<!-- Archivo generado por el conversor Helvia/WordPress -->
<!-- Pablo Murillo Ávila -->
<!-- Contiene la información equivalente entre Helvia y WordPress -->
<!-- Para realizar la importación es necesario tener instalado en el destino el plugin "Importador de WordPress" -->

<rss version="2.0"
	xmlns:excerpt="http://wordpress.org/export/1.2/excerpt/"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:wp="http://wordpress.org/export/1.2/"
>

<channel>
	<title>'.$titulo.'</title>
	<link>'.$link.'</link>
	<description>'.$descripcion.'</description>
	<pubDate>'.date('D\, d M Y H\:i\:s +0000').'</pubDate>
	<language>es-ES</language>
	<wp:wxr_version>1.2</wp:wxr_version>
	<wp:base_site_url>'.$link.'</wp:base_site_url>
	<wp:base_blog_url>'.$link.'</wp:base_blog_url>

');

	// Autores
	echo ("[".date('H:i:s')." INFO]: Descargando autores...\n");
	$consulta_autor='SELECT distinct nombre_usuario from btc_publicaciones;';
	$resultado_autor=mysqli_query($conexion,$consulta_autor);
	$array_autores=array();
	while($autor=mysqli_fetch_assoc($resultado_autor)) {
		array_push($array_autores,$autor['nombre_usuario']);
	}
	foreach ($array_autores as $autor) {
		$consulta_email_autor='SELECT email_usuario from btc_publicaciones where nombre_usuario="'.$autor.'";';
		$resultado_email_autor=mysqli_query($conexion,$consulta_email_autor);
		$email_autor=mysqli_fetch_assoc($resultado_email_autor);
		fwrite ($archivo,'	<wp:author><wp:author_id>'.(array_search($autor,$array_autores)+1).'</wp:author_id><wp:author_login><![CDATA['.usuario($autor).']]></wp:author_login><wp:author_email><![CDATA['.$email_autor['email_usuario'].']]></wp:author_email><wp:author_display_name><![CDATA['.$autor.']]></wp:author_display_name><wp:author_first_name><![CDATA[]]></wp:author_first_name><wp:author_last_name><![CDATA[]]></wp:author_last_name></wp:author>
');
	}
	fwrite ($archivo,'
');
	$numero_autores=count($array_autores);
	echo ("[".date('H:i:s')." INFO]: Se han descargado ".$numero_autores." autores.\n");

	// Categorías
	echo ("[".date('H:i:s')." INFO]: Descargando categorías...\n");
	$consulta_categoria='SELECT nombre_categoria from btc_categorias;';
	$resultado_categoria=mysqli_query($conexion,$consulta_categoria);
	$contador_etiquetas_categorias=1;
	while($categoria=mysqli_fetch_assoc($resultado_categoria)) {
		fwrite ($archivo,'	<wp:category>
		<wp:term_id>'.$contador_etiquetas_categorias.'</wp:term_id>
		<wp:category_nicename><![CDATA['.slug($categoria['nombre_categoria']).']]></wp:category_nicename>
		<wp:category_parent><![CDATA[]]></wp:category_parent>
		<wp:cat_name><![CDATA['.$categoria['nombre_categoria'].']]></wp:cat_name>
	</wp:category>
	<wp:term>
		<wp:term_id><![CDATA['.$contador_etiquetas_categorias.']]></wp:term_id>
		<wp:term_taxonomy><![CDATA[category]]></wp:term_taxonomy>
		<wp:term_slug><![CDATA['.slug($categoria['nombre_categoria']).']]></wp:term_slug>
		<wp:term_parent><![CDATA[]]></wp:term_parent>
		<wp:term_name><![CDATA['.$categoria['nombre_categoria'].']]></wp:term_name>
	</wp:term>
');
		$contador_etiquetas_categorias=$contador_etiquetas_categorias+1;
	}
	echo ("[".date('H:i:s')." INFO]: Se han descargado ".($contador_etiquetas_categorias-1)." categorías.\n");

	// Etiquetas
	echo ("[".date('H:i:s')." INFO]: Descargando etiquetas...\n");
	$consulta_etiquetas='SELECT tags from btc_publicaciones;';
	$resultado_etiquetas=mysqli_query($conexion,$consulta_etiquetas);
	$array_etiquetas_parcial=array();
	$array_etiquetas_completo=array();
	while($etiquetas_parcial=mysqli_fetch_assoc($resultado_etiquetas)) {
		$array_etiquetas_parcial=explode(',',$etiquetas_parcial['tags']);
		$array_etiquetas_completo=array_merge($array_etiquetas_parcial,$array_etiquetas_completo);
	}
	$array_etiquetas=array_filter(array_unique($array_etiquetas_completo));
	foreach ($array_etiquetas as $etiqueta) {
		fwrite ($archivo,'	<wp:tag>
		<wp:term_id>'.$contador_etiquetas_categorias.'</wp:term_id>
		<wp:tag_slug><![CDATA['.slug($etiqueta).']]></wp:tag_slug>
		<wp:tag_name><![CDATA['.$etiqueta.']]></wp:tag_name>
	</wp:tag>
	<wp:term>
		<wp:term_id><![CDATA['.$contador_etiquetas_categorias.']]></wp:term_id>
		<wp:term_taxonomy><![CDATA[post_tag]]></wp:term_taxonomy>
		<wp:term_slug><![CDATA['.slug($etiqueta).']]></wp:term_slug>
		<wp:term_parent><![CDATA[]]></wp:term_parent>
		<wp:term_name><![CDATA['.$etiqueta.']]></wp:term_name>
	</wp:term>
');
		$contador_etiquetas_categorias=$contador_etiquetas_categorias+1;
	}
	echo ("[".date('H:i:s')." INFO]: Se han descargado ".count($array_etiquetas)." etiquetas.\n");

	// Generador
	fwrite ($archivo,'
	<generator>https://wordpress.org/?v=4.9.6</generator>

');

	// Publicaciones y comentarios
	echo ("[".date('H:i:s')." INFO]: Descargando publicaciones y comentarios...\n");
	if ($limitar_publicaciones == "no") {
		$consulta_publicacion='SELECT id_pub,titulo_pub,fecha_alta_pub,nombre_usuario,enable_pub from btc_publicaciones order by id_pub;';
	}
	else {
		$consulta_publicacion='SELECT id_pub,titulo_pub,fecha_alta_pub,nombre_usuario,enable_pub from btc_publicaciones order by id_pub limit '.$limite_de_publicaciones.' offset '.$publicacion_inicio.';';
		echo ("[".date('H:i:s')." INFO]: Límite de publicaciones activado a ".$limite_de_publicaciones." publicaciones a partir de la ".$publicacion_inicio.".\n");
	}
	$resultado_publicacion=mysqli_query($conexion,$consulta_publicacion);
	while($publicacion=mysqli_fetch_assoc($resultado_publicacion)) {
		$fecha_pub = DateTime::createFromFormat('Y-m-d H:i:s',$publicacion['fecha_alta_pub']);
		fwrite ($archivo,'	<item>
		<title>'.$publicacion['titulo_pub'].'</title>
		<link>'.$link.'?p='.$publicacion['id_pub'].'</link>
		<pubDate>'.$fecha_pub->format('D, d M Y H:i:s +0000').'</pubDate>
		<dc:creator><![CDATA['.usuario($publicacion['nombre_usuario']).']]></dc:creator>
		<guid isPermaLink="false">'.$link.'?p='.$publicacion['id_pub'].'</guid>
		<description></description>
		<content:encoded><![CDATA['.file_get_contents($ruta_pub.$publicacion['id_pub'].'.html').']]></content:encoded>
		<excerpt:encoded><![CDATA[]]></excerpt:encoded>
		<wp:post_id>'.$publicacion['id_pub'].'</wp:post_id>
		<wp:post_date><![CDATA['.$publicacion['fecha_alta_pub'].']]></wp:post_date>
		<wp:post_date_gmt><![CDATA['.$publicacion['fecha_alta_pub'].']]></wp:post_date_gmt>
		<wp:comment_status><![CDATA[open]]></wp:comment_status>
		<wp:ping_status><![CDATA[open]]></wp:ping_status>
		<wp:post_name><![CDATA['.slug($publicacion['titulo_pub']).']]></wp:post_name>
');
		if ($publicacion['enable_pub'] == 0) {
			fwrite ($archivo,'		<wp:status><![CDATA[draft]]></wp:status>');
		}
		else {
			fwrite ($archivo,'		<wp:status><![CDATA[publish]]></wp:status>');
		}
		fwrite ($archivo,'
		<wp:post_parent>0</wp:post_parent>
		<wp:menu_order>0</wp:menu_order>
		<wp:post_type><![CDATA[post]]></wp:post_type>
		<wp:post_password><![CDATA[]]></wp:post_password>
		<wp:is_sticky>0</wp:is_sticky>');
		$consulta_categoria='SELECT id_categoria from btc_rel_cat_pub where id_pub='.$publicacion['id_pub'].';';
		$resultado_categoria=mysqli_query($conexion,$consulta_categoria);
		while($id_categoria=mysqli_fetch_assoc($resultado_categoria)) {
			if ($id_categoria['id_categoria'] != 0) {
				$consulta_nombre_categoria='SELECT nombre_categoria from btc_categorias where id_categoria='.$id_categoria['id_categoria'].';';
				$resultado_nombre_categoria=mysqli_query($conexion,$consulta_nombre_categoria);
				$categoria=mysqli_fetch_assoc($resultado_nombre_categoria);
				fwrite ($archivo,'
		<category domain="category" nicename="'.slug($categoria['nombre_categoria']).'"><![CDATA['.$categoria['nombre_categoria'].']]></category>');
			}
		}
		$consulta_etiquetas='SELECT tags from btc_publicaciones where id_pub='.$publicacion['id_pub'].';';
		$resultado_etiquetas=mysqli_query($conexion,$consulta_etiquetas);
		$array_etiquetas_pre=array();
		$array_etiquetas=array();
		while($etiquetas=mysqli_fetch_assoc($resultado_etiquetas)) {
			$array_etiquetas_pre=explode(',',$etiquetas['tags']);
		}
		$array_etiquetas=array_filter(array_unique($array_etiquetas_pre));
		foreach ($array_etiquetas as $etiqueta) {
			fwrite ($archivo,'
		<category domain="post_tag" nicename="'.slug($etiqueta).'"><![CDATA['.$etiqueta.']]></category>');
		}
		$consulta_comentario='SELECT id_comentario,nombre_usuario,email_usuario,texto_comentario,fecha_alta_comentario,activo from btc_comentarios where id_pub='.$publicacion['id_pub'].';';
		$resultado_comentario=mysqli_query($conexion,$consulta_comentario);
		while($comentario=mysqli_fetch_assoc($resultado_comentario)) {
			if ($eliminar_emoticonos == "si") {
				$texto_comentario = emoticonos($comentario['texto_comentario']);
			}
			else {
				$texto_comentario = $comentario['texto_comentario'];
			}
			fwrite ($archivo,'
		<wp:comment>
			<wp:comment_id>'.$comentario['id_comentario'].'</wp:comment_id>
			<wp:comment_author><![CDATA['.$comentario['nombre_usuario'].']]></wp:comment_author>
			<wp:comment_author_email><![CDATA['.$comentario['email_usuario'].']]></wp:comment_author_email>
			<wp:comment_author_url></wp:comment_author_url>
			<wp:comment_author_IP><![CDATA[]]></wp:comment_author_IP>
			<wp:comment_date><![CDATA['.$comentario['fecha_alta_comentario'].']]></wp:comment_date>
			<wp:comment_date_gmt><![CDATA['.$comentario['fecha_alta_comentario'].']]></wp:comment_date_gmt>
			<wp:comment_content><![CDATA['.$texto_comentario.']]></wp:comment_content>');
			if ($comentario['activo'] == 0) {
				fwrite ($archivo,'
			<wp:comment_approved><![CDATA[0]]></wp:comment_approved>');
			}
			else {
				fwrite ($archivo,'
			<wp:comment_approved><![CDATA[1]]></wp:comment_approved>');
			}
			fwrite ($archivo,'
			<wp:comment_type><![CDATA[]]></wp:comment_type>
			<wp:comment_parent>0</wp:comment_parent>
			<wp:comment_user_id>0</wp:comment_user_id>
		</wp:comment>');
		}
		fwrite ($archivo,'
	</item>
');
	}
	if ($limitar_publicaciones == "no") {
		$consulta_num_publicacion='SELECT count(*) as numero from btc_publicaciones;';
		$resultado_num_publicacion=mysqli_query($conexion,$consulta_num_publicacion);
		$num_publicacion=mysqli_fetch_assoc($resultado_num_publicacion);
		echo ("[".date('H:i:s')." INFO]: Se han descargado ".$num_publicacion['numero']." publicaciones.\n");
	}
	else {
		echo ("[".date('H:i:s')." INFO]: Se han descargado ".$limite_de_publicaciones." publicaciones.\n");
	}

	// Finalización
	fwrite ($archivo,'</channel>
</rss>
');
	fclose ($archivo);
	echo ("[".date('H:i:s')." INFO]: Archivo de de importación de WordPress '".$nombre_archivo."' creado.\n");
	echo ("[".date('H:i:s')." INFO]: El proceso ha terminado correctamente.\n");
	die;
?>
